//+------------------------------------------------------------------+
//|                                            Zigzagy Auto Fibo.mq4 |
//|                 Copyright  2005-2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//|                                             Created By: madboy84 |
//|                                           Special Thanks To Siro |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, madboy84"
#property link      "http://www.forexfactory.com/"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- indicator parameters
extern int ExtDepth=90;
extern int ExtDeviation=5;
extern int ExtBackstep=3;
extern color ZigZag.Color= Red;
extern int   ZigZag.Width=4;
extern bool  Show.Current.Fibo.Expansion = true;
extern color Current.Fibo.Expansion.Color= Aqua;
extern bool  Show.Last.Fibo.Expansion = false;
extern color Last.Fibo.Expansion.Color= LightGray;
extern color Fibo_0.00_Color= Yellow;
extern color Fibo_23.6_Color= Red;
extern color Fibo_38.2_Color= White;
extern color Fibo_50.0_Color= White;
extern color Fibo_61.8_Color= Red;
extern color Fibo_76.4_Color= White;
extern color Fibo_100.0_Color= Aqua;
//---- indicator buffers
double ZigzagBuffer[];
double HighMapBuffer[];
double LowMapBuffer[];


int level=3; // recounting's depth 


bool downloadhistory=false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION,0,ZigZag.Width,ZigZag.Color);
//---- indicator buffers mapping
   SetIndexBuffer(0,ZigzagBuffer);
   SetIndexBuffer(1,HighMapBuffer);
   SetIndexBuffer(2,LowMapBuffer); 
   SetIndexEmptyValue(0,0.0);

//---- indicator short name
   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("FIBO100 Label");
   ObjectDelete("FIBO100 Line");
   ObjectDelete("FIBO0 Label");
   ObjectDelete("FIBO0 Line");
   ObjectDelete("FIBO236 Label");
   ObjectDelete("FIBO236 Line");
   ObjectDelete("FIBO382 Label");
   ObjectDelete("FIBO382 Line");
   ObjectDelete("FIBO50 Label");
   ObjectDelete("FIBO50 Line");
   ObjectDelete("FIBO618 Label");
   ObjectDelete("FIBO618 Line");
   ObjectDelete("FIBO764 Label");
   ObjectDelete("FIBO764 Line");
   ObjectDelete("CurrentFIBOexpansion");
   ObjectDelete("LastFIBOexpansion");
   ObjectDelete("WaveStart");
   ObjectDelete("WaveEnd");

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
         int pos1,pos2,pos3,pos4;
         int j;
   int i, counted_bars = IndicatorCounted();
   int limit,counterZ,whatlookfor;
   int shift,back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   if (counted_bars==0 && downloadhistory) // history was downloaded
     {
      ArrayInitialize(ZigzagBuffer,0.0);
      ArrayInitialize(HighMapBuffer,0.0);
      ArrayInitialize(LowMapBuffer,0.0);
     }
   if (counted_bars==0) 
     {
      limit=Bars-ExtDepth;
      downloadhistory=true;
     }
   if (counted_bars>0) 
     {
      while (counterZ<level && i<100000)
        {
         res=ZigzagBuffer[i];
         if (res!=0) counterZ++;
         i++;
        }
      i--;
      limit=i;
      if (LowMapBuffer[i]!=0) 
        {
         curlow=LowMapBuffer[i];
         whatlookfor=1;
        }
      else
        {
         curhigh=HighMapBuffer[i];
         whatlookfor=-1;
        }
      for (i=limit-1;i>=0;i--)  
        {
         ZigzagBuffer[i]=0.0;  
         LowMapBuffer[i]=0.0;
         HighMapBuffer[i]=0.0;
        }
     }
      
   for(shift=limit; shift>=0; shift--)
   {
      val=Low[iLowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=LowMapBuffer[shift+back];
               if((res!=0)&&(res>val)) LowMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      if (Low[shift]==val) LowMapBuffer[shift]=val; else LowMapBuffer[shift]=0.0;
      //--- high
      val=High[iHighest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=HighMapBuffer[shift+back];
               if((res!=0)&&(res<val)) HighMapBuffer[shift+back]=0.0; 
              } 
           }
        }
      if (High[shift]==val) HighMapBuffer[shift]=val; else HighMapBuffer[shift]=0.0;
   }

   // final cutting 
   if (whatlookfor==0)
     {
      lastlow=0;
      lasthigh=0;  
     }
   else
     {
      lastlow=curlow;
      lasthigh=curhigh;
     }
   for (shift=limit;shift>=0;shift--)
     {
      res=0.0;
      switch(whatlookfor)
        {
         case 0: // look for peak or lawn 
            if (lastlow==0 && lasthigh==0)
              {
               if (HighMapBuffer[shift]!=0)
                 {
                  lasthigh=High[shift];
                  lasthighpos=shift;
                  whatlookfor=-1;
                  ZigzagBuffer[shift]=lasthigh;
                  res=1;
                 }
               if (LowMapBuffer[shift]!=0)
                 {
                  lastlow=Low[shift];
                  lastlowpos=shift;
                  whatlookfor=1;
                  ZigzagBuffer[shift]=lastlow;
                  res=1;
                 }
              }
             break;  
         case 1: // look for peak
            if (LowMapBuffer[shift]!=0.0 && LowMapBuffer[shift]<lastlow && HighMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lastlowpos]=0.0;
               lastlowpos=shift;
               lastlow=LowMapBuffer[shift];
               ZigzagBuffer[shift]=lastlow;
               res=1;
              }
            if (HighMapBuffer[shift]!=0.0 && LowMapBuffer[shift]==0.0)
              {
               lasthigh=HighMapBuffer[shift];
               lasthighpos=shift;
               ZigzagBuffer[shift]=lasthigh;
               whatlookfor=-1;
               res=1;
              }   
            break;               
         case -1: // look for lawn
            if (HighMapBuffer[shift]!=0.0 && HighMapBuffer[shift]>lasthigh && LowMapBuffer[shift]==0.0)
              {
               ZigzagBuffer[lasthighpos]=0.0;
               lasthighpos=shift;
               lasthigh=HighMapBuffer[shift];
               ZigzagBuffer[shift]=lasthigh;
              }
            if (LowMapBuffer[shift]!=0.0 && HighMapBuffer[shift]==0.0)
              {
               lastlow=LowMapBuffer[shift];
               lastlowpos=shift;
               ZigzagBuffer[shift]=lastlow;
               whatlookfor=1;
              }   
            break;               
         default: return; 
        }

     }
  pos1=-1; j=0;
  while(pos1<limit && j<1)
  {
      pos1++; 
      if(ZigzagBuffer[pos1]!=0)
        j++;

  }
  pos2=-1; j=0;
  while(pos2<limit && j<2)
  {
      pos2++; 
      if(ZigzagBuffer[pos2]!=0)
        j++;

  }
  pos3=-1; j=0;
  while(pos3<limit && j<3)
  {
      pos3++; 
      if(ZigzagBuffer[pos3]!=0)
        j++;

  }
  pos4=-1; j=0;
  while(pos4<limit && j<4)
  {
      pos4++; 
      if(ZigzagBuffer[pos4]!=0)
        j++;

  } 
  
//+---------------------+
//| Fibo lines function |
//+---------------------+
  double FIBO100,FIBO0,Q,FIBO236,FIBO382,FIBO50,FIBO618,FIBO764;
  double WaveStart,WaveEnd;

  
  if(whatlookfor==1)
  {
  FIBO100=High[iHighest(NULL,0,MODE_HIGH,1,lasthighpos)];
  FIBO0=Low[iLowest(NULL,0,MODE_LOW,1,lastlowpos)];
  Q=FIBO100-FIBO0;
  FIBO236=FIBO0+(Q*0.236);
  FIBO382=FIBO0+(Q*0.382);
  FIBO50=FIBO0+(Q*0.5);
  FIBO618=FIBO0+(Q*0.618);
  FIBO764=FIBO0+(Q*0.764);
  }
  else
  {
  FIBO0=High[iHighest(NULL,0,MODE_HIGH,1,lasthighpos)];
  FIBO100=Low[iLowest(NULL,0,MODE_LOW,1,lastlowpos)];
  Q=MathAbs(FIBO100-FIBO0);
  FIBO236=FIBO0-(Q*0.236);
  FIBO382=FIBO0-(Q*0.382);
  FIBO50=FIBO0-(Q*0.5);
  FIBO618=FIBO0-(Q*0.618);
  FIBO764=FIBO0-(Q*0.764);
  }
  
  
//+---------------------------------------------------------+
//| Set line labels and arrows on chart window              |
//+---------------------------------------------------------+
//---- Arrows ----//
       if(ObjectFind("WaveStart") != 0)
         {
           ObjectCreate("WaveStart", OBJ_ARROW, 0, Time[pos2],FIBO100);
           ObjectSet("WaveStart", OBJPROP_ARROWCODE, 2);
         }
       else
         {
           ObjectMove("WaveStart", 0, Time[pos2],FIBO100);
         }
       //----
       if(ObjectFind("WaveEnd") != 0)
         {
           ObjectCreate("WaveEnd", OBJ_ARROW, 0, Time[pos1],FIBO0);
           ObjectSet("WaveEnd", OBJPROP_ARROWCODE, 3);
         }
       else
         {
           ObjectMove("WaveEnd", 0, Time[pos1],FIBO0);
         }
         
//---- Fibo Lines ----//
       if(ObjectFind("FIBO100 label") != 0)
         {
           ObjectCreate("FIBO100 label", OBJ_TEXT, 0, Time[3], FIBO100);
           ObjectSetText("FIBO100 label", "100.0%", 8, "Arial", Fibo_100.0_Color);
         }
       else
         {
           ObjectMove("FIBO100 label", 0, Time[3], FIBO100);
         }
       //----
       if(ObjectFind("FIBO0 label") != 0)
         {
           ObjectCreate("FIBO0 label", OBJ_TEXT, 0, Time[3], FIBO0);
           ObjectSetText("FIBO0 label", "0.0%", 8, "Arial", Fibo_0.00_Color);
         }
       else
         {
           ObjectMove("FIBO0 label", 0, Time[3], FIBO0);
         }
       //----
       if(ObjectFind("FIBO236 label") != 0)
         {
           ObjectCreate("FIBO236 label", OBJ_TEXT, 0, Time[3], FIBO236);
           ObjectSetText("FIBO236 label", "23.6%", 12, "High Tower Text", Fibo_23.6_Color);
         }
       else
         {
           ObjectMove("FIBO236 label", 0, Time[3], FIBO236);
         }
       //----
       if(ObjectFind("FIBO382 label") != 0)
         {
           ObjectCreate("FIBO382 label", OBJ_TEXT, 0, Time[3], FIBO382);
           ObjectSetText("FIBO382 label", "38.2%", 8, "Arial", Fibo_38.2_Color);
         }
       else
         {
           ObjectMove("FIBO382 label", 0, Time[3], FIBO382);
         }
       //----
       if(ObjectFind("FIBO50 label") != 0)
         {
           ObjectCreate("FIBO50 label", OBJ_TEXT, 0, Time[3], FIBO50);
           ObjectSetText("FIBO50 label", "50.0%", 8, "Arial", Fibo_50.0_Color);
         }
       else
         {
           ObjectMove("FIBO50 label", 0, Time[3], FIBO50);
         }
       //----
       if(ObjectFind("FIBO618 label") != 0)
         {
           ObjectCreate("FIBO618 label", OBJ_TEXT, 0, Time[3], FIBO618);
           ObjectSetText("FIBO618 label", "61.8%", 12, "High Tower Text", Fibo_61.8_Color);
         }
       else
         {
           ObjectMove("FIBO618 label", 0, Time[3], FIBO618);
         }
       //----
       if(ObjectFind("FIBO764 label") != 0)
         {
           ObjectCreate("FIBO764 label", OBJ_TEXT, 0, Time[3], FIBO764);
           ObjectSetText("FIBO764 label", "76.4%", 8, "Arial", Fibo_76.4_Color);
         }
       else
         {
           ObjectMove("FIBO764 label", 0, Time[3], FIBO764);
         }
       //------------------------------------------------------------
         if(ObjectFind("FIBO100 line") != 0)
         {
           ObjectCreate("FIBO100 line", OBJ_HLINE, 0, Time[3], FIBO100);
           ObjectSet("FIBO100 line", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("FIBO100 line", OBJPROP_COLOR, Fibo_100.0_Color);
         }
       else
         {
           ObjectMove("FIBO100 line", 0, Time[3], FIBO100);
         }
       //----
       if(ObjectFind("FIBO0 line") != 0)
         {
           ObjectCreate("FIBO0 line", OBJ_HLINE, 0, Time[3], FIBO0);
           ObjectSet("FIBO0 line", OBJPROP_STYLE, STYLE_DASH);
           ObjectSet("FIBO0 line", OBJPROP_COLOR, Fibo_0.00_Color);
         }
       else
         {
           ObjectMove("FIBO0 line", 0, Time[3], FIBO0);
         }
       //----
         if(ObjectFind("FIBO236 line") != 0)
         {
           ObjectCreate("FIBO236 line", OBJ_HLINE, 0, Time[3], FIBO236);
           ObjectSet("FIBO236 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
           ObjectSet("FIBO236 line", OBJPROP_COLOR, Fibo_23.6_Color);
         }
       else
         {
           ObjectMove("FIBO236 line", 0, Time[3], FIBO236);
         }
       //----
         if(ObjectFind("FIBO382 line") != 0)
         {
           ObjectCreate("FIBO382 line", OBJ_HLINE, 0, Time[3], FIBO382);
           ObjectSet("FIBO382 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
           ObjectSet("FIBO382 line", OBJPROP_COLOR, Fibo_38.2_Color);
         }
       else
         {
           ObjectMove("FIBO382 line", 0, Time[3], FIBO382);
         }
       //----
         if(ObjectFind("FIBO50 line") != 0)
         {
           ObjectCreate("FIBO50 line", OBJ_HLINE, 0, Time[3], FIBO50);
           ObjectSet("FIBO50 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
           ObjectSet("FIBO50 line", OBJPROP_COLOR, Fibo_50.0_Color);
         }
       else
         {
           ObjectMove("FIBO50 line", 0, Time[3], FIBO50);
         }
       //----
         if(ObjectFind("FIBO618 line") != 0)
         {
           ObjectCreate("FIBO618 line", OBJ_HLINE, 0, Time[3], FIBO618);
           ObjectSet("FIBO618 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
           ObjectSet("FIBO618 line", OBJPROP_COLOR, Fibo_61.8_Color);
         }
       else
         {
           ObjectMove("FIBO618 line", 0, Time[3], FIBO618);
         }
       //----
         if(ObjectFind("FIBO764 line") != 0)
         {
           ObjectCreate("FIBO764 line", OBJ_HLINE, 0, Time[3], FIBO764);
           ObjectSet("FIBO764 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
           ObjectSet("FIBO764 line", OBJPROP_COLOR, Fibo_76.4_Color);
         }
       else
         {
           ObjectMove("FIBO764 line", 0, Time[3], FIBO764);
         }
//---- Fibo Expansion ----//
if (Show.Current.Fibo.Expansion == true)
   {
   if(whatlookfor==1){
         if(ObjectFind("CurrentFIBOexpansion") == -1)
         {
           ObjectCreate("CurrentFIBOexpansion", OBJ_EXPANSION,0,Time[pos3],Low[pos3],Time[lasthighpos],FIBO100,Time[lastlowpos],FIBO0);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_STYLE, STYLE_DOT);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_COLOR, Current.Fibo.Expansion.Color);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_LEVELCOLOR, Current.Fibo.Expansion.Color);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIBOLEVELS, 5);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+0, 0.382);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+1, 0.5);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+2, 0.618);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+3, 0.764);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+4, 1);
           ObjectSetFiboDescription("CurrentFIBOexpansion", 0, "38.2%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 1, "50.0%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 2, "61.6%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 3, "76.4%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 4, "100.0%%-%$");
         }
         else
         {
           ObjectMove("CurrentFIBOexpansion", 0, Time[pos3],Low[pos3]);
           ObjectMove("CurrentFIBOexpansion", 1, Time[lasthighpos],FIBO100);
           ObjectMove("CurrentFIBOexpansion", 2, Time[lastlowpos],FIBO0);
         }
         }
    else
         {
         if(ObjectFind("CurrentFIBOexpansion") == -1)
         {
           ObjectCreate("CurrentFIBOexpansion", OBJ_EXPANSION,0,Time[pos3],High[pos3],Time[lastlowpos],FIBO100,Time[lasthighpos],FIBO0);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_STYLE, STYLE_DOT);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_COLOR, Current.Fibo.Expansion.Color);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_LEVELCOLOR, Current.Fibo.Expansion.Color);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIBOLEVELS, 5); 
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+0, 0.382);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+1, 0.5);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+2, 0.618);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+3, 0.764);
           ObjectSet("CurrentFIBOexpansion", OBJPROP_FIRSTLEVEL+4, 1);
           ObjectSetFiboDescription("CurrentFIBOexpansion", 0, "38.2%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 1, "50.0%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 2, "61.6%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 3, "76.4%%-%$");
           ObjectSetFiboDescription("CurrentFIBOexpansion", 4, "100.0%%-%$");
           
         }
         else
         {
           ObjectMove("CurrentFIBOexpansion", 0, Time[pos3],High[pos3]);
           ObjectMove("CurrentFIBOexpansion", 1, Time[lastlowpos],FIBO100);
           ObjectMove("CurrentFIBOexpansion", 2, Time[lasthighpos],FIBO0);
         }
         }
   }
       //----
if (Show.Last.Fibo.Expansion == true)
   {
   if(whatlookfor==-1)
   {
         if(ObjectFind("LastFIBOexpansion") == -1)
         {
           ObjectCreate("LastFIBOexpansion", OBJ_EXPANSION,0,Time[pos4],Low[pos4],Time[pos3],High[pos3],Time[pos2],Low[pos2]);
           ObjectSet("LastFIBOexpansion", OBJPROP_STYLE, STYLE_DOT);
           ObjectSet("LastFIBOexpansion", OBJPROP_COLOR, Last.Fibo.Expansion.Color);
           ObjectSet("LastFIBOexpansion", OBJPROP_LEVELCOLOR, Last.Fibo.Expansion.Color);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIBOLEVELS, 5);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+0, 0.382);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+1, 0.5);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+2, 0.618);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+3, 0.764);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+4, 1);
           ObjectSetFiboDescription("LastFIBOexpansion", 0, "last 38.2%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 1, "last 50.0%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 2, "last 61.6%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 3, "last 76.4%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 4, "last 100.0%%-%$");
         }
         else
         {
           ObjectMove("LastFIBOexpansion", 0, Time[pos4],Low[pos4]);
           ObjectMove("LastFIBOexpansion", 1, Time[pos3],High[pos3]);
           ObjectMove("LastFIBOexpansion", 2, Time[pos2],Low[pos2]);
         }
         }
    else
         {
         if(ObjectFind("LastFIBOexpansion") == -1)
         {
           ObjectCreate("LastFIBOexpansion", OBJ_EXPANSION,0,Time[pos4],High[pos4],Time[pos3],Low[pos3],Time[pos2],High[pos2]);
           ObjectSet("LastFIBOexpansion", OBJPROP_STYLE, STYLE_DOT);
           ObjectSet("LastFIBOexpansion", OBJPROP_COLOR, Last.Fibo.Expansion.Color);
           ObjectSet("LastFIBOexpansion", OBJPROP_LEVELCOLOR, Last.Fibo.Expansion.Color);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIBOLEVELS, 5); 
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+0, 0.382);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+1, 0.5);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+2, 0.618);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+3, 0.764);
           ObjectSet("LastFIBOexpansion", OBJPROP_FIRSTLEVEL+4, 1);
           ObjectSetFiboDescription("LastFIBOexpansion", 0, "last 38.2%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 1, "last 50.0%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 2, "last 61.6%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 3, "last 76.4%%-%$");
           ObjectSetFiboDescription("LastFIBOexpansion", 4, "last 100.0%%-%$");
         }
         else
         {
           ObjectMove("LastFIBOexpansion", 0, Time[pos4],High[pos4]);
           ObjectMove("LastFIBOexpansion", 1, Time[pos3],Low[pos3]);
           ObjectMove("LastFIBOexpansion", 2, Time[pos2],High[pos2]);
         }
         }
   }
         
       Comment(ZigzagBuffer[0]);
     return(0);
}


   
//+------------------------------------------------------------------+